/***************************************************************************
                          thegame-network.cpp  -  description
                             -------------------
    begin                : Fri Mar 22 2002
    copyright            : (C) 2002 by Christoph Maciejewski
    email                : chrmac@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include "thegame.h"
//#include "warshipswindow.h"  // Win32

bool TheGameApp::connectNetwork()
{
	int result;    	
	
	if(create_socket != -1)
	{
		qDebug("close connection...");
		::close(new_socket);
  	::close(create_socket);           	
	}
	
  if(typeN == 1)
  {   	
  	result = startServer();
  	if(result != 0)
  	{
  		//statusBar()->message(tr("Network error: Can't connect"));
  		network = false;
  		return false;
  	}
  }else
  {
  	result = startClient();
  	if(result != 0)
  	{
  		//statusBar()->message(tr("Network error: Can't connect"));
  		network = false;
  		return false;
  	}
  }

  return true;
}

//////////////////////// Serverdienst starten ///////////////////////////////
int TheGameApp::startServer()
{ 	
	int addrlen;
  int bufsize = 1024;
  char buffer[1024];
  struct sockaddr_in address;
  char startCommand [] = "CLIENT_OK";
  int portNum = 15000;

  if ((create_socket = socket(AF_INET,SOCK_STREAM,0)) > 0)
  {
  	qDebug("Socket erfolgreich erstellt...\n");
  }
  else
  {
    qDebug("ERROR-> Network error - can't create socket.\n");
    statusBar()->message(tr("Network error - can't create socket."));
    return 1;
  }

  address.sin_family = AF_INET;
  address.sin_addr.s_addr = INADDR_ANY;
  address.sin_port = htons(portNum);

  //-------------- Bind -----------------------
  if (::bind(create_socket, (struct sockaddr *)&address, sizeof(address)) == 0)
  {
  	qDebug("Socket angebunden\n");
  }
  else
  {
    qDebug("ERROR-> Network error - can't bind socket.");
    statusBar()->message(tr("Network error - can't bind socket."));
    return 2;
  }
  //-------------------------------------------

  qDebug("Waiting for Client...");	

  //------------ Clients zulassen ----------------
  ::listen(create_socket, 1);
  addrlen = sizeof(struct sockaddr_in);
  new_socket = ::accept(create_socket, (struct sockaddr *)&address, (socklen_t *)&addrlen);
  //----------------------------------------------

  if (new_socket > 0)
  {
  	QString w;
		w.sprintf("The Client >%s< is connected...", ::inet_ntoa(address.sin_addr));
		qDebug(w);
   	QApplication::beep();
  }

  do
  {
    qDebug("Server: (send): SERVER_OK");
    ::send(new_socket, "SERVER_OK", bufsize, 1);
    qDebug("Server: waiting for answer...");
    ::recv(new_socket, buffer, bufsize, 0);
    qDebug("Server: (recv): %s", buffer);
  }while(strcmp(buffer, startCommand)); //solange kein CLIENT_OK

  qDebug("Server: there is a Warship client! Lets play!");
  strcpy(clientIP, ::inet_ntoa(address.sin_addr));

  //------- Send wind data ----------------------
  qDebug("Server: (send): WIND (%d)", randomN);
  char tmpW[10];
  sprintf(tmpW, "%d", randomN);
  ::send(new_socket, tmpW, 10, 1);
  ::recv(new_socket, buffer, bufsize, 0);
  //---------------------------------------------

  //------- Send window size --------------------
  qDebug("Server: (send): WINDOW_SIZE (%d)", this->xres);
  sprintf(tmpW, "%d", this->xres);
  ::send(new_socket, tmpW, 10, 1);
  //---------------------------------------------

  return 0;
}

////////////////////////  Clientdienst starten ////////////////////////
int TheGameApp::startClient()
{ 	
  int bufsize = 1024;
  char buffer[1024];
  struct sockaddr_in address;
  char startCommand [] = "SERVER_OK";
  int portNum = 15000;

  //------------ Socket erstellen ---------------------
  if ((create_socket = ::socket(AF_INET,SOCK_STREAM,0)) > 0)
  {
     qDebug("Socket erfolgreich erstellt...\n");
  }
  else
  {
     qDebug("ERROR-> Network error - can't create socket.\n");
     statusBar()->message(tr("Network error - can't create socket."));
     return 1;
  }
  //---------------------------------------------------

  address.sin_family = AF_INET;
  address.sin_port = htons(portNum);	  // Port# setzen
  address.sin_addr.s_addr = inet_addr(serverIP);
  //inet_pton(AF_INET, serverIP, &address.sin_addr);

  //------------- Verbinden ---------------------------
  if (::connect(create_socket, (struct sockaddr *)&address, sizeof(address)) == 0)
  {
     qDebug("Verbindung zum Server >%s< steht\n", ::inet_ntoa(address.sin_addr));
  }
  else
  {
     qDebug("ERROR-> Network error - can't connect the Server.\n");
     statusBar()->message(tr("Network error - can't connect the Server."));
     return 1;
  }

  do
  {
    qDebug("Client: waiting for server identification...");
    ::recv(create_socket, buffer, bufsize, 0);
    qDebug("Client: (recv): %s", buffer);
  }while(strcmp(buffer, startCommand)); //solange kein SERVER_OK

  qDebug("Client: (send): CLIENT_OK");
  ::send(create_socket, "CLIENT_OK", bufsize, 1);
  qDebug("Client: Server found! Lets play!");

  strcpy(serverIP, ::inet_ntoa(address.sin_addr));

  //------- Recive wind data --------------------
  qDebug("Client: waiting for WIND info...");
  ::recv(create_socket, buffer, bufsize, 0);
  qDebug("Client: (recv): %s", buffer);
  ::send(create_socket, "WIND_OK", bufsize, 1);
  randomN = atoi(buffer);
  //srand(randomN);
  //---------------------------------------------

  //------- Recive window size ------------------
  qDebug("Client: waiting for WINDOW_SIZE...");
  ::recv(create_socket, buffer, bufsize, 0);
  qDebug("Client: (recv): %s", buffer);

  if(atoi(buffer) != this->xres)
    QMessageBox::about(this, tr("Resize window!"), tr("Your window will be resized to server size."));
    
  this->xres = atoi(buffer);
  //this->resize(xres, yres);  // in father method!
  //---------------------------------------------

	return 0;
}

//////////////////////// Datenaustausch ////////////////////////////////
void TheGameApp::reciveData()
{
  int bufsize = 1024;
  char buffer[1024];
  int mySocket, tmpAnge, tmpSpeed, tmpProj;
  char * tmp;

  if(typeN == 1) mySocket = new_socket; else mySocket = create_socket;

  //--------- Recive shot data ----------------
  qDebug("Game-Data: waiting for shot data...");
  ::recv(mySocket, buffer, bufsize, 0);
  
  //--------- segregate the data (blank separated) -------
  tmpAnge = (int)strtod(buffer, &tmp);
  strcpy(buffer, tmp);
  tmpSpeed = (int)strtod(buffer, &tmp);
  strcpy(buffer, tmp);
  tmpProj = (int)strtod(buffer, &tmp);
  strcpy(buffer, tmp);
  //------------------------------------------------------
  
  if(typeN == 1)
  {
    ange2 = tmpAnge;
  	ange2d = ange2 * 3.1416 / 180;
    speed2 = tmpSpeed;
    proj2 = tmpProj;
  }
  else
  {
    ange1 = tmpAnge;
  	ange1d = ange1 * 3.1416 / 180;
    speed1 = tmpSpeed;
    proj1 = tmpProj;
  }	
}

void TheGameApp::sendData()
{
	int bufsize = 1024;
  char buffer[1024];
  int mySocket;

  if(typeN == 1) mySocket = new_socket; else mySocket = create_socket;

  //----------- Send shot data -----------------
  if(typeN == 1)
  {
    sprintf(buffer, "%d %d %d", ange1, speed1, proj1);
    qDebug("Game-Data: (send): angle, speed, proj");
	::send(mySocket, buffer, bufsize, 0);
  }
  else
  {
    sprintf(buffer, "%d %d %d", ange2, speed2, proj2);
    qDebug("Game-Data: (send): angle, speed, proj");
	::send(mySocket, buffer, bufsize, 0);
  }    
}


